/** SUDP Protocol data stream receiving server 
 *  - UDP data receiving port : 9901
 *  - TCP Communication/Control port : 9902
 *  - $Id: sudp_recv_clt.cpp 272 2017-11-15 01:00:12Z vlbi $
 * @Author M.Sekido
 * @Version $Rev: 273 $
 * @Date  $Date: 2017-11-15 10:02:19 +0900 (水, 15 11月 2017) $
 */

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <vector>
using namespace std;

#include "SUDPProto.hpp"
const char* version_str = "$Rev: 273 $ updated $Date: 2017-11-15 10:02:19 +0900 (水, 15 11月 2017) $ ";
char *me;  // My name

void usage(){
  fprintf(stderr, "Usage: %s [-d <UDP port>] [-c <Control port>] [-s <mtu byte>] \n", me);
  fprintf(stderr, "  [-a <src host>] [-g <logging file>] \n");
  fprintf(stderr, "  ----------------------------------------------------\n");
  fprintf(stderr, " -a <data src host>, default=localhost \n");
  fprintf(stderr, " -d <UDP data port>, default=%d \n",DEFAULT_SUDP_PORT);
  fprintf(stderr, " -c <TCP Control port>, default=%d \n",DEFAULT_SUDP_CTRL_PORT);
  fprintf(stderr, " -s <mtu byte> Packet size (default=1500).\n");
  fprintf(stderr, " -g <log file> File Logging for Debug.\n");
  fprintf(stderr. "  Version: %s \n", version_str);
  exit(1);
}


int main(int argc, char *argv[]){
  me = (me = strrchr(argv[0], '/')) == NULL ? argv[0] : me+1; /* My name */ 
  int ctl_port = DEFAULT_SUDP_CTRL_PORT;
  int dat_port = DEFAULT_SUDP_PORT;
  string logfile;
  string src_host="localhost";
  
  int k=0;
  while (k >= 0) { 
    switch (k = getopt(argc, argv, "ha:c:d:g:s:")) { 
    case 'a':   src_host  = optarg; break;
    case 'c':   ctl_port  = atoi(optarg); break;
    case 'd':   dat_port  = atoi(optarg); break;
    case 's':   mtu  = atoi(optarg); break;
    case 'g':   logfile  = optarg; break;
    case 'h':    usage(); break;
    case ':':    cerr << "Error: missing argument.\n"; break;
    case '?':    usage(); break;
    }
  }
  


}
