

#ifndef __FILEDUMPER__
#define __FILEDUMPER__
/** FileDumper (Output) class library
 * @Version $Rev: 157 $
 * @Author M.Sekido
 * @Date  $Date: 2015-02-06 11:46:23 +0900 (金, 06  2月 2015) $
 * $Id: FileDumper.hpp 157 2015-02-06 02:46:23Z vlbi $ 
 */

#include <string>

#include "VirDumper.hpp"

/** FileDumper
 * Function: Output data to Net/File. When multiple Filedumper instances are cleated and
 * used for output data streaming, Input model could be shared, but Protocol model 
 * instances must be independents at Set_IO(), because VLBI_Proto has socket and VLBI_Frame
 * pinters in the protocol should be independent for multile output.
 * $Author: vlbi $
 * $Revision: 157 $ $Date: 2015-02-06 11:46:23 +0900 (金, 06  2月 2015) $
 * $Id: FileDumper.hpp 157 2015-02-06 02:46:23Z vlbi $
 */

class FileDumper: public VirDumper{
public: 
  /** Default Constructor  */
  FileDumper();
  /** Default Desructor  */
  ~FileDumper(); 
  void* thread_func(); ///< Thread function
  int Set_IO(VLBI_Proto *v, InDev_Model *k, int ith); // add 2014/12/9 miya
  int Writing(const time_t s_epoch=0); ///< Main function for writing data 
  int Sending(); ///< Main function to sending data 
  bool Ready(); ///< Check/Make ready
  VLBI_Proto* proto_mdl[MAX_NOUT];  ///< Output Protocol(including header format) used 2014/12/9 modify [16] miya
};
/** Set in Input model and Output Protocol
 *  Then Input module started.
 */
//---------------------------------------add 2014/12/9 miya start---

inline  int FileDumper::Set_IO(VLBI_Proto *v, InDev_Model *k, const int ith){
  proto_mdl[ith] = v;
  input_mdl=k;
  vlbi_frame = v->pVLBI_Frame();

  return 0;
}
//---------------------------------------add 2014/12/9 miya end----

/** Destructor */
inline FileDumper::~FileDumper(){
  if( proto_mdl[0] != 0 ) for(int i=0; i<NFileout; i++) proto_mdl[i] = 0; //proto_mdl[0] = 0;
}

#endif
