/** 
 * @Version $Rev: 56 $
 * @Author M.Sekido
 * @Date  $Date: 2013-07-03 20:40:14 +0900 (Wed, 03 Jul 2013) $
 * $Id: vdif_test.cpp 56 2013-07-03 11:40:14Z vlbi $ 
 */
#include <iostream>
using namespace std;

#include "vdif.hpp"
//#include "vdif.h"

void usage(){
  cerr << "Usage: -f <out xfilename> [-t <sec from ref>] [-v <0|1>]\n";
  cerr << " -v: Valid(0) or Invalid(1)\n";
  exit(1);
}

int main(int argc, char* argv[]){	 
  
  string fname;
  uint32_t sec(0);
  int valid(0);

  int k=0;
  while (k >= 0) { 
    switch (k = getopt(argc, argv, "hf:t:v:")) { 
    case 'h':   usage();     break;
    case 'f':   fname = optarg; break;
    case 't':   sec = atol(optarg); break;
    case 'v':   valid = atoi(optarg); break;
    case '?':    usage(); break;
    case ':':    cerr << "lack of parameters \n"; usage(); break;
    }
  }

  FILE *fp(0);
  if(!fname.empty()){
    fp = fopen(fname.c_str(),"w");
  }

  VDIF_header vdh;
  struct VDIF_header vdh1;
  printf("sizeof VDIF = %d Bytes struct Vdif-size=%d\n",sizeof(vdh), sizeof(vdh1));
  if(valid) vdh.Set_Invalid();
  vdh.Set_SecRef(sec);
  uint32_t *p = (uint32_t*)&vdh;
  for(int i=0; i<100; i++){
    if(fp) fwrite(&vdh,sizeof(vdh),1,fp);
    vdh.Frame_up(); vdh.add();
    vdh.Print();
    fprintf(stdout,"struct =%08X %08X %08X %08X\n", *p,*(p+1),*(p+2),*(p+3));
  }
  if(fp){fclose(fp); fp=0;}
}	
